blob: 1656c9eed006bdce115ed6e7673246847319783a [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
Felipe Contreras85176d72013-11-17 23:12:43 -050022 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
Ævar Arnfjörð Bjarmason9dbf20e2022-02-27 11:25:11 +010024 TEST_DIRECTORY=$(pwd)
25else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
31 #
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
Felipe Contreras85176d72013-11-17 23:12:43 -050036 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070037fi
38if test -z "$TEST_OUTPUT_DIRECTORY"
39then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
43fi
Ævar Arnfjörð Bjarmasonb9638d72022-02-27 11:25:12 +010044GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
Ævar Arnfjörð Bjarmason9dbf20e2022-02-27 11:25:11 +010046then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
49fi
Johannes Schindelinee9e66e2022-10-18 10:59:04 +000050if test -f "$GIT_BUILD_DIR/GIT-BUILD-DIR"
51then
52 GIT_BUILD_DIR="$(cat "$GIT_BUILD_DIR/GIT-BUILD-DIR")" || exit 1
53 # On Windows, we must convert Windows paths lest they contain a colon
54 case "$(uname -s)" in
55 *MINGW*)
56 GIT_BUILD_DIR="$(cygpath -au "$GIT_BUILD_DIR")"
57 ;;
58 esac
59fi
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070060
Ævar Arnfjörð Bjarmason66c1a562022-02-27 11:25:10 +010061# Prepend a string to a VAR using an arbitrary ":" delimiter, not
62# adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
63#
64# VAR=$1${VAR:+${1:+$2}$VAR}
65#
66# Usage (using ":" as the $2 delimiter):
67#
68# prepend_var VAR : VALUE
69prepend_var () {
Ævar Arnfjörð Bjarmason361fa322022-06-30 12:18:35 +020070 eval "$1=\"$3\${$1:+${3:+$2}\$$1}\""
Ævar Arnfjörð Bjarmason66c1a562022-02-27 11:25:10 +010071}
72
73# If [AL]SAN is in effect we want to abort so that we notice
74# problems. The GIT_SAN_OPTIONS variable can be used to set common
75# defaults shared between [AL]SAN_OPTIONS.
76prepend_var GIT_SAN_OPTIONS : abort_on_error=1
Ævar Arnfjörð Bjarmason361fa322022-06-30 12:18:35 +020077prepend_var GIT_SAN_OPTIONS : strip_path_prefix="$GIT_BUILD_DIR/"
Ævar Arnfjörð Bjarmason66c1a562022-02-27 11:25:10 +010078
Jeff Kingd0cc5792017-07-10 09:24:35 -040079# If we were built with ASAN, it may complain about leaks
80# of program-lifetime variables. Disable it by default to lower
81# the noise level. This needs to happen at the start of the script,
82# before we even do our "did we build git yet" check (since we don't
83# want that one to complain to stderr).
Ævar Arnfjörð Bjarmason66c1a562022-02-27 11:25:10 +010084prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
85prepend_var ASAN_OPTIONS : detect_leaks=0
Jeff Kingd0cc5792017-07-10 09:24:35 -040086export ASAN_OPTIONS
87
Ævar Arnfjörð Bjarmason66c1a562022-02-27 11:25:10 +010088prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
Ævar Arnfjörð Bjarmason71f26792022-02-27 11:25:13 +010089prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
Jeff King85b81b32017-09-05 09:04:04 -040090export LSAN_OPTIONS
91
Jeff King252d6932023-09-21 00:18:25 -040092prepend_var UBSAN_OPTIONS : $GIT_SAN_OPTIONS
93export UBSAN_OPTIONS
94
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080095if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053096then
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080097 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053098 exit 1
99fi
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700100. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
101export PERL_PATH SHELL_PATH
102
Patrick Steinhardtade15522021-07-20 08:32:26 +0200103# In t0000, we need to override test directories of nested testcases. In case
104# the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
105# reset this value to instead contain what the developer has specified. We thus
106# have this knob to allow overriding the directory.
107if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
108then
109 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
110fi
111
Johannes Schindelinb02e7d52019-04-12 02:37:24 -0700112# Disallow the use of abbreviated options in the test suite by default
113if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
114then
115 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
116 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
117fi
118
Ævar Arnfjörð Bjarmason97c8aac2021-05-10 16:19:09 +0200119# Explicitly set the default branch name for testing, to avoid the
120# transitory "git init" warning under --verbose.
121: ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
122export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
123
Junio C Hamanoc2116a12008-03-06 19:04:26 -0800124################################################################
125# It appears that people try to run tests without building...
Johannes Schindelin8abfdf42018-11-14 08:32:11 -0800126"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700127if test $? != 1
128then
Johannes Schindelined306e42018-11-14 08:32:10 -0800129 if test -n "$GIT_TEST_INSTALLED"
130 then
131 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
132 else
133 echo >&2 'error: you do not seem to have built git yet.'
134 fi
Pavel Roskind9bdd392005-08-10 22:10:01 -0400135 exit 1
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700136fi
Junio C Hamanoc2116a12008-03-06 19:04:26 -0800137
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100138store_arg_to=
Matheus Tavares78dc0882020-03-22 12:58:57 -0300139opt_required_arg=
140# $1: option string
141# $2: name of the var where the arg will be stored
142mark_option_requires_arg () {
143 if test -n "$opt_required_arg"
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100144 then
Matheus Tavares78dc0882020-03-22 12:58:57 -0300145 echo "error: options that require args cannot be bundled" \
146 "together: '$opt_required_arg' and '$1'" >&2
147 exit 1
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100148 fi
Matheus Tavares78dc0882020-03-22 12:58:57 -0300149 opt_required_arg=$1
150 store_arg_to=$2
151}
152
Johannes Schindelin78d5e4c2022-05-21 22:18:46 +0000153# These functions can be overridden e.g. to output JUnit XML
154start_test_output () { :; }
155start_test_case_output () { :; }
156finalize_test_case_output () { :; }
157finalize_test_output () { :; }
158
Matheus Tavares78dc0882020-03-22 12:58:57 -0300159parse_option () {
160 local opt="$1"
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100161
162 case "$opt" in
163 -d|--d|--de|--deb|--debu|--debug)
164 debug=t ;;
165 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
166 immediate=t ;;
167 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
168 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
169 -r)
Matheus Tavares78dc0882020-03-22 12:58:57 -0300170 mark_option_requires_arg "$opt" run_list
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100171 ;;
172 --run=*)
173 run_list=${opt#--*=} ;;
174 -h|--h|--he|--hel|--help)
175 help=t ;;
176 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
177 verbose=t ;;
178 --verbose-only=*)
179 verbose_only=${opt#--*=}
180 ;;
181 -q|--q|--qu|--qui|--quie|--quiet)
182 # Ignore --quiet under a TAP::Harness. Saying how many tests
183 # passed without the ok/not ok details is always an error.
184 test -z "$HARNESS_ACTIVE" && quiet=t ;;
185 --with-dashes)
186 with_dashes=t ;;
Johannes Schindelindd167a32019-01-29 06:19:37 -0800187 --no-bin-wrappers)
188 no_bin_wrappers=t ;;
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100189 --no-color)
190 color= ;;
191 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
192 valgrind=memcheck
193 tee=t
194 ;;
195 --valgrind=*)
196 valgrind=${opt#--*=}
197 tee=t
198 ;;
199 --valgrind-only=*)
200 valgrind_only=${opt#--*=}
201 tee=t
202 ;;
203 --tee)
204 tee=t ;;
205 --root=*)
206 root=${opt#--*=} ;;
207 --chain-lint)
208 GIT_TEST_CHAIN_LINT=1 ;;
209 --no-chain-lint)
210 GIT_TEST_CHAIN_LINT=0 ;;
211 -x)
212 trace=t ;;
213 -V|--verbose-log)
214 verbose_log=t
215 tee=t
216 ;;
Johannes Schindelin22231902019-01-29 06:19:27 -0800217 --write-junit-xml)
Johannes Schindelin78d5e4c2022-05-21 22:18:46 +0000218 . "$TEST_DIRECTORY/test-lib-junit.sh"
Johannes Schindelin22231902019-01-29 06:19:27 -0800219 ;;
Johannes Schindelin0f5ae592022-05-21 22:18:51 +0000220 --github-workflow-markup)
221 . "$TEST_DIRECTORY/test-lib-github-workflow-markup.sh"
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100222 ;;
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100223 --stress)
224 stress=t ;;
225 --stress=*)
Johannes Schindelinf5457372019-03-03 06:44:55 -0800226 echo "error: --stress does not accept an argument: '$opt'" >&2
227 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
228 exit 1
229 ;;
230 --stress-jobs=*)
231 stress=t;
SZEDER Gábor134768c2021-01-26 23:05:33 +0100232 stress_jobs=${opt#--*=}
233 case "$stress_jobs" in
SZEDER Gábor7d661e52019-02-11 20:58:03 +0100234 *[!0-9]*|0*|"")
Johannes Schindelinf5457372019-03-03 06:44:55 -0800235 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100236 exit 1
237 ;;
238 *) # Good.
239 ;;
240 esac
241 ;;
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100242 --stress-limit=*)
Johannes Schindelinde69e6f2019-03-03 06:44:54 -0800243 stress=t;
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100244 stress_limit=${opt#--*=}
245 case "$stress_limit" in
SZEDER Gábor7d661e52019-02-11 20:58:03 +0100246 *[!0-9]*|0*|"")
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100247 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
248 exit 1
249 ;;
250 *) # Good.
251 ;;
252 esac
253 ;;
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +0200254 --invert-exit-code)
255 invert_exit_code=t
256 ;;
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100257 *)
258 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
259 esac
Matheus Tavares78dc0882020-03-22 12:58:57 -0300260}
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100261
Matheus Tavares78dc0882020-03-22 12:58:57 -0300262# Parse options while taking care to leave $@ intact, so we will still
263# have all the original command line options when executing the test
264# script again for '--tee' and '--verbose-log' later.
265for opt
266do
267 if test -n "$store_arg_to"
268 then
269 eval $store_arg_to=\$opt
270 store_arg_to=
271 opt_required_arg=
272 continue
273 fi
274
275 case "$opt" in
276 --*|-?)
277 parse_option "$opt" ;;
278 -?*)
279 # bundled short options must be fed separately to parse_option
280 opt=${opt#-}
281 while test -n "$opt"
282 do
283 extra=${opt#?}
284 this=${opt%$extra}
285 opt=$extra
286 parse_option "-$this"
287 done
288 ;;
289 *)
290 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
291 esac
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100292done
293if test -n "$store_arg_to"
294then
Matheus Tavares78dc0882020-03-22 12:58:57 -0300295 echo "error: $opt_required_arg requires an argument" >&2
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100296 exit 1
297fi
298
299if test -n "$valgrind_only"
300then
301 test -z "$valgrind" && valgrind=memcheck
302 test -z "$verbose" && verbose_only="$valgrind_only"
303elif test -n "$valgrind"
304then
305 test -z "$verbose_log" && verbose=t
306fi
307
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100308if test -n "$stress"
309then
310 verbose=t
311 trace=t
312 immediate=t
313fi
314
315TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100316TEST_NAME="$(basename "$0" .sh)"
SZEDER Gáborffe1afe2019-08-05 23:04:47 +0200317TEST_NUMBER="${TEST_NAME%%-*}"
318TEST_NUMBER="${TEST_NUMBER#t}"
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100319TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100320TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
Ævar Arnfjörð Bjarmason366bd122022-07-28 01:13:34 +0200321TEST_RESULTS_SAN_FILE_PFX=trace
322TEST_RESULTS_SAN_DIR_SFX=leak
323TEST_RESULTS_SAN_FILE=
324TEST_RESULTS_SAN_DIR="$TEST_RESULTS_DIR/$TEST_NAME.$TEST_RESULTS_SAN_DIR_SFX"
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +0200325TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP=
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100326TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
SZEDER Gábor61f292d2019-01-05 02:08:57 +0100327test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
328case "$TRASH_DIRECTORY" in
329/*) ;; # absolute path is good
330 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
331esac
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100332
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +0200333# Utility functions using $TEST_RESULTS_* variables
334nr_san_dir_leaks_ () {
335 # stderr piped to /dev/null because the directory may have
336 # been "rmdir"'d already.
337 find "$TEST_RESULTS_SAN_DIR" \
338 -type f \
339 -name "$TEST_RESULTS_SAN_FILE_PFX.*" 2>/dev/null |
Jeff King370ef7e2023-08-28 14:37:35 -0400340 xargs grep -lv "Unable to get registers from thread" |
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +0200341 wc -l
342}
343
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100344# If --stress was passed, run this test repeatedly in several parallel loops.
345if test "$GIT_TEST_STRESS_STARTED" = "done"
346then
347 : # Don't stress test again.
348elif test -n "$stress"
349then
SZEDER Gábor134768c2021-01-26 23:05:33 +0100350 if test -n "$stress_jobs"
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100351 then
SZEDER Gábor134768c2021-01-26 23:05:33 +0100352 job_count=$stress_jobs
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100353 elif test -n "$GIT_TEST_STRESS_LOAD"
354 then
355 job_count="$GIT_TEST_STRESS_LOAD"
356 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
357 test -n "$job_count"
358 then
359 job_count=$((2 * $job_count))
360 else
361 job_count=8
362 fi
363
364 mkdir -p "$TEST_RESULTS_DIR"
365 stressfail="$TEST_RESULTS_BASE.stress-failed"
366 rm -f "$stressfail"
367
368 stress_exit=0
369 trap '
370 kill $job_pids 2>/dev/null
371 wait
372 stress_exit=1
373 ' TERM INT HUP
374
375 job_pids=
376 job_nr=0
377 while test $job_nr -lt "$job_count"
378 do
379 (
380 GIT_TEST_STRESS_STARTED=done
381 GIT_TEST_STRESS_JOB_NR=$job_nr
382 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
383
384 trap '
385 kill $test_pid 2>/dev/null
386 wait
387 exit 1
388 ' TERM INT
389
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100390 cnt=1
391 while ! test -e "$stressfail" &&
392 { test -z "$stress_limit" ||
393 test $cnt -le $stress_limit ; }
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100394 do
395 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
396 test_pid=$!
397
398 if wait $test_pid
399 then
400 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
401 else
402 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
403 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
404 fi
405 cnt=$(($cnt + 1))
406 done
407 ) &
408 job_pids="$job_pids $!"
409 job_nr=$(($job_nr + 1))
410 done
411
412 wait
413
414 if test -f "$stressfail"
415 then
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100416 stress_exit=1
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100417 echo "Log(s) of failed test run(s):"
418 for failed_job_nr in $(sort -n "$stressfail")
419 do
420 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
421 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
422 done
423 rm -rf "$TRASH_DIRECTORY.stress-failed"
424 # Move the last one.
425 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
426 fi
427
428 exit $stress_exit
429fi
430
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530431# if --tee was passed, write the output not only to the terminal, but
432# additionally to the file test-results/$BASENAME.out, too.
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100433if test "$GIT_TEST_TEE_STARTED" = "done"
434then
435 : # do not redirect again
436elif test -n "$tee"
437then
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100438 mkdir -p "$TEST_RESULTS_DIR"
Jeff King452320f2016-10-21 06:48:00 -0400439
440 # Make this filename available to the sub-process in case it is using
441 # --verbose-log.
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100442 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
Jeff King452320f2016-10-21 06:48:00 -0400443 export GIT_TEST_TEE_OUTPUT_FILE
444
445 # Truncate before calling "tee -a" to get rid of the results
446 # from any previous runs.
447 >"$GIT_TEST_TEE_OUTPUT_FILE"
448
Jeff King3f824e92017-12-08 05:47:22 -0500449 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100450 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
451 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530452 exit
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100453fi
454
455if test -n "$trace" && test -n "$test_untraceable"
456then
457 # '-x' tracing requested, but this test script can't be reliably
458 # traced, unless it is run with a Bash version supporting
459 # BASH_XTRACEFD (introduced in Bash v4.1).
460 #
461 # Perform this version check _after_ the test script was
462 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
463 # '--verbose-log', so the right shell is checked and the
464 # warning is issued only once.
465 if test -n "$BASH_VERSION" && eval '
466 test ${BASH_VERSINFO[0]} -gt 4 || {
467 test ${BASH_VERSINFO[0]} -eq 4 &&
468 test ${BASH_VERSINFO[1]} -ge 1
469 }
470 '
471 then
472 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
473 else
474 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
475 trace=
476 fi
477fi
478if test -n "$trace" && test -z "$verbose_log"
479then
480 verbose=t
481fi
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530482
Felipe Contreras390b44e2021-08-05 14:48:25 -0500483# Since bash 5.0, checkwinsize is enabled by default which does
484# update the COLUMNS variable every time a non-builtin command
485# completes, even for non-interactive shells.
486# Disable that since we are aiming for repeatability.
487test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
488
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700489# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400490# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700491LANG=C
492LC_ALL=C
493PAGER=cat
494TZ=UTC
Ævar Arnfjörð Bjarmasonc49a1772021-06-29 13:29:36 +0200495COLUMNS=80
496export LANG LC_ALL PAGER TZ COLUMNS
Eric Wong8ff99e72006-07-11 12:01:54 -0700497EDITOR=:
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +0000498
Stefano Lattarini661bfd12012-03-02 19:48:36 +0100499# A call to "unset" with no arguments causes at least Solaris 10
500# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
501# deriving from the command substitution clustered with the other
502# ones.
Ævar Arnfjörð Bjarmasonc49a1772021-06-29 13:29:36 +0200503unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500504 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +0200505 my $ok = join("|", qw(
506 TRACE
507 DEBUG
Jens Lehmann730477f2011-03-28 21:16:09 +0200508 TEST
509 .*_TEST
510 PROVE
511 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +0100512 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700513 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400514 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000515 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200516 ));
517 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500518 print join("\n", @vars);
519')
Genki Sky7976e902018-02-15 21:46:04 -0500520unset XDG_CACHE_HOME
Jeff King5adf84e2012-07-24 07:53:05 -0400521unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200522unset GITPERLLIB
Josh Steadmon944d8082022-01-13 19:33:36 -0800523unset GIT_TRACE2_PARENT_NAME
524unset GIT_TRACE2_PARENT_SID
Prarit Bhargavad8b82172019-10-29 08:09:14 -0400525TEST_AUTHOR_LOCALNAME=author
526TEST_AUTHOR_DOMAIN=example.com
527GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800528GIT_AUTHOR_NAME='A U Thor'
Jeff Kingf2e39372020-07-09 16:42:04 -0400529GIT_AUTHOR_DATE='1112354055 +0200'
Prarit Bhargavad8b82172019-10-29 08:09:14 -0400530TEST_COMMITTER_LOCALNAME=committer
531TEST_COMMITTER_DOMAIN=example.com
532GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800533GIT_COMMITTER_NAME='C O Mitter'
Jeff Kingf2e39372020-07-09 16:42:04 -0400534GIT_COMMITTER_DATE='1112354055 +0200'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500535GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800536GIT_MERGE_AUTOEDIT=no
537export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800538export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
539export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jeff Kingf2e39372020-07-09 16:42:04 -0400540export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
Jonathan Niederd33738d2009-11-11 17:56:07 -0600541export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700542
brian m. carlson02a32db2020-07-29 23:14:24 +0000543GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
544export GIT_DEFAULT_HASH
Elijah Newrenf3b964a2021-03-20 00:03:56 +0000545GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
546export GIT_TEST_MERGE_ALGORITHM
brian m. carlson02a32db2020-07-29 23:14:24 +0000547
Karsten Blees124647c2014-07-12 02:03:01 +0200548# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
549GIT_TRACE_BARE=1
550export GIT_TRACE_BARE
551
Derrick Stoleeb8de3d62021-11-29 13:47:45 +0000552# Some tests scan the GIT_TRACE2_EVENT feed for events, but the
553# default depth is 2, which frequently causes issues when the
554# events are wrapped in new regions. Set it to a sufficiently
555# large depth to avoid custom changes in the test suite.
556GIT_TRACE2_EVENT_NESTING=100
557export GIT_TRACE2_EVENT_NESTING
558
Ben Peart1f357b02018-09-18 23:29:36 +0000559# Use specific version of the index file format
560if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100561then
Ben Peart1f357b02018-09-18 23:29:36 +0000562 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100563 export GIT_INDEX_VERSION
564fi
565
Jeff King5338ed22020-10-21 23:24:00 -0400566if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
567then
568 GIT_PERL_FATAL_WARNINGS=1
569 export GIT_PERL_FATAL_WARNINGS
570fi
571
Eric Wong412e4ca2021-10-29 00:15:52 +0000572case $GIT_TEST_FSYNC in
573'')
574 GIT_TEST_FSYNC=0
575 export GIT_TEST_FSYNC
576 ;;
577esac
578
Phillip Wood067109a2022-04-09 12:28:37 +0000579# Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
Ævar Arnfjörð Bjarmason5e7c8b72022-09-28 12:01:54 +0200580# the test with valgrind and have not compiled with conflict SANITIZE
581# options.
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100582if test -n "$valgrind" ||
Phillip Wood067109a2022-04-09 12:28:37 +0000583 test -n "$SANITIZE_ADDRESS" ||
Ævar Arnfjörð Bjarmason5e7c8b72022-09-28 12:01:54 +0200584 test -n "$SANITIZE_LEAK" ||
René Scharfeee1431b2012-09-26 22:16:39 +0200585 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700586then
587 setup_malloc_check () {
588 : nothing
589 }
590 teardown_malloc_check () {
591 : nothing
592 }
593else
Phillip Wooda6a58f72022-08-04 13:38:25 +0000594 _USE_GLIBC_TUNABLES=
595 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
596 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
597 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
598 then
599 _USE_GLIBC_TUNABLES=YesPlease
600 fi
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700601 setup_malloc_check () {
Michael J Gruberbaedc592022-03-09 22:41:43 +0100602 local g
603 local t
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700604 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
605 export MALLOC_CHECK_ MALLOC_PERTURB_
Phillip Wooda6a58f72022-08-04 13:38:25 +0000606 if test -n "$_USE_GLIBC_TUNABLES"
Elia Pinto131b94a2022-03-04 13:37:02 +0000607 then
608 g=
609 LD_PRELOAD="libc_malloc_debug.so.0"
610 for t in \
611 glibc.malloc.check=1 \
612 glibc.malloc.perturb=165
613 do
614 g="${g#:}:$t"
615 done
616 GLIBC_TUNABLES=$g
617 export LD_PRELOAD GLIBC_TUNABLES
618 fi
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700619 }
620 teardown_malloc_check () {
621 unset MALLOC_CHECK_ MALLOC_PERTURB_
Elia Pinto131b94a2022-03-04 13:37:02 +0000622 unset LD_PRELOAD GLIBC_TUNABLES
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700623 }
624fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700625
Junio C Hamano886a3902007-04-24 11:21:47 -0700626# Protect ourselves from common misconfiguration to export
627# CDPATH into the environment
628unset CDPATH
629
Bert Wesarg5565f472009-11-18 17:15:19 +0100630unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100631unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100632
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200633case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01006341|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400635 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100636 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200637esac
638
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700639# Line feed
640LF='
641'
642
Denton Liubd482d62019-09-05 15:10:05 -0700643# Single quote
644SQ=\'
645
Jeff Kinga42643a2014-12-15 18:15:20 -0500646# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
647# when case-folding filenames
648u200c=$(printf '\342\200\214')
649
Ævar Arnfjörð Bjarmason70507912021-09-11 13:17:51 +0200650export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
Thomas Rast342e9ef2012-02-17 11:25:09 +0100651
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400652test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400653 test -t 1 &&
654 tput bold >/dev/null 2>&1 &&
655 tput setaf 1 >/dev/null 2>&1 &&
656 tput sgr0 >/dev/null 2>&1
657 ) &&
658 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700659
Richard Hansenca92a662015-06-17 15:06:25 -0400660if test -n "$color"
661then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400662 # Save the color control sequences now rather than run tput
663 # each time say_color() is called. This is done for two
664 # reasons:
665 # * TERM will be changed to dumb
666 # * HOME will be changed to a temporary directory and tput
667 # might need to read ~/.terminfo from the original HOME
668 # directory to get the control sequences
669 # Note: This approach assumes the control sequences don't end
670 # in a newline for any terminal of interest (command
671 # substitutions strip trailing newlines). Given that most
672 # (all?) terminals in common use are related to ECMA-48, this
673 # shouldn't be a problem.
674 say_color_error=$(tput bold; tput setaf 1) # bold red
675 say_color_skip=$(tput setaf 4) # blue
676 say_color_warn=$(tput setaf 3) # brown/yellow
677 say_color_pass=$(tput setaf 2) # green
678 say_color_info=$(tput setaf 6) # cyan
679 say_color_reset=$(tput sgr0)
680 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400681 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400682 test -z "$1" && test -n "$quiet" && return
683 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400684 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400685 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400686 }
687else
688 say_color() {
689 test -z "$1" && test -n "$quiet" && return
690 shift
691 printf "%s\n" "$*"
692 }
693fi
694
Philippe Blainadd52402021-09-06 04:38:59 +0000695USER_TERM="$TERM"
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400696TERM=dumb
Philippe Blainadd52402021-09-06 04:38:59 +0000697export TERM USER_TERM
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400698
Fabian Stelzera6714082021-12-01 09:53:15 +0100699# What is written by tests to stdout and stderr is sent to different places
700# depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
701# with --tee option, etc.). We save the original stdin to FD #6 and stdout and
702# stderr to #5 and #7, so that the test framework can use them (e.g. for
703# printing errors within the test framework) independently of the test mode.
704exec 5>&1
705exec 6<&0
706exec 7>&2
707
Ævar Arnfjörð Bjarmason8583bf72021-10-14 02:47:28 +0200708_error_exit () {
Johannes Schindelin78d5e4c2022-05-21 22:18:46 +0000709 finalize_test_output
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200710 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200711 exit 1
712}
713
Ævar Arnfjörð Bjarmason8583bf72021-10-14 02:47:28 +0200714error () {
715 say_color error "error: $*"
716 _error_exit
717}
718
SZEDER Gábor165293a2018-11-19 14:13:26 +0100719BUG () {
720 error >&7 "bug in the test script: $*"
721}
722
Ævar Arnfjörð Bjarmason234383c2021-10-14 02:47:29 +0200723BAIL_OUT () {
724 test $# -ne 1 && BUG "1 param"
725
726 # Do not change "Bail out! " string. It's part of TAP syntax:
727 # https://testanything.org/tap-specification.html
728 local bail_out="Bail out! "
729 local message="$1"
730
Fabian Stelzera6714082021-12-01 09:53:15 +0100731 say_color >&5 error $bail_out "$message"
Ævar Arnfjörð Bjarmason234383c2021-10-14 02:47:29 +0200732 _error_exit
733}
734
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200735say () {
736 say_color info "$*"
737}
738
Jeff King614fe012016-10-22 00:45:06 -0400739if test -n "$HARNESS_ACTIVE"
740then
741 if test "$verbose" = t || test -n "$verbose_only"
742 then
Ævar Arnfjörð Bjarmason234383c2021-10-14 02:47:29 +0200743 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
Jeff King614fe012016-10-22 00:45:06 -0400744 fi
745fi
746
Michele Ballabio570f3222007-11-10 15:17:25 +0100747test "${test_description}" != "" ||
748error "Test script did not set test_description."
749
750if test "$help" = "t"
751then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100752 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100753 exit 0
754fi
755
Jeff King452320f2016-10-21 06:48:00 -0400756if test "$verbose_log" = "t"
757then
758 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
759elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700760then
761 exec 4>&2 3>&1
762else
763 exec 4>/dev/null 3>/dev/null
764fi
765
Jeff Kingd88785e2016-05-11 09:44:04 -0400766# Send any "-x" output directly to stderr to avoid polluting tests
767# which capture stderr. We can do this unconditionally since it
768# has no effect if tracing isn't turned on.
769#
770# Note that this sets up the trace fd as soon as we assign the variable, so it
771# must come after the creation of descriptor 4 above. Likewise, we must never
772# unset this, as it has the side effect of closing descriptor 4, which we
773# use to show verbose tests to the user.
774#
775# Note also that we don't need or want to export it. The tracing is local to
776# this shell, and we would not want to influence any shells we exec.
777BASH_XTRACEFD=4
778
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700779test_failure=0
780test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800781test_fixed=0
782test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200783test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700784
Fabian Stelzer49da4042021-11-20 16:03:59 +0100785test_missing_prereq=
786
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000787test_external_has_tap=0
788
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100789die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200790 code=$?
Johannes Schindelin900721e2019-03-13 13:24:11 +0100791 # This is responsible for running the atexit commands even when a
792 # test script run with '--immediate' fails, or when the user hits
793 # ctrl-C, i.e. when 'test_done' is not invoked at all.
794 test_atexit_handler || code=$?
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200795 if test -n "$GIT_EXIT_OK"
796 then
797 exit $code
798 else
799 echo >&5 "FATAL: Unexpected exit with code $code"
800 exit 1
801 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100802}
803
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200804GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100805trap 'die' EXIT
SZEDER Gáborc5c39f42019-03-13 13:24:09 +0100806# Disable '-x' tracing, because with some shells, notably dash, it
807# prevents running the cleanup commands when a test script run with
808# '--verbose-log -x' is interrupted.
809trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
Pavel Roskin41184272005-08-11 12:00:40 -0400810
Thomas Rast12a29b12012-02-17 11:25:08 +0100811# The user-facing functions are loaded from a separate file so that
812# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700813. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800814
Junio C Hamano886856a2005-05-14 00:24:27 -0700815# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100816# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700817
818test_ok_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100819 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200820 say_color "" "ok $test_count - $@"
Johannes Schindelin3069f2a2022-05-21 22:18:56 +0000821 finalize_test_case_output ok "$@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700822}
823
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +0200824_invert_exit_code_failure_end_blurb () {
825 say_color warn "# faked up failures as TODO & now exiting with 0 due to --invert-exit-code"
826}
827
Junio C Hamano886856a2005-05-14 00:24:27 -0700828test_failure_ () {
Johannes Schindelin3069f2a2022-05-21 22:18:56 +0000829 failure_label=$1
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100830 test_failure=$(($test_failure + 1))
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +0200831 local pfx=""
832 if test -n "$invert_exit_code" # && test -n "$HARNESS_ACTIVE"
833 then
834 pfx="# TODO induced breakage (--invert-exit-code):"
835 fi
836 say_color error "not ok $test_count - ${pfx:+$pfx }$1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700837 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100838 printf '%s\n' "$*" | sed -e 's/^/# /'
Ævar Arnfjörð Bjarmasonbbfbcd22022-03-23 21:51:31 +0100839 if test -n "$immediate"
840 then
841 say_color error "1..$test_count"
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +0200842 if test -n "$invert_exit_code"
843 then
844 finalize_test_output
845 _invert_exit_code_failure_end_blurb
846 GIT_EXIT_OK=t
847 exit 0
848 fi
Ævar Arnfjörð Bjarmasonbbfbcd22022-03-23 21:51:31 +0100849 _error_exit
850 fi
Johannes Schindelin3069f2a2022-05-21 22:18:56 +0000851 finalize_test_case_output failure "$failure_label" "$@"
Junio C Hamano886856a2005-05-14 00:24:27 -0700852}
853
Junio C Hamano41ac4142008-02-01 01:50:53 -0800854test_known_broken_ok_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800855 test_fixed=$(($test_fixed+1))
Ævar Arnfjörð Bjarmason6d006802022-07-28 01:13:29 +0200856 say_color error "ok $test_count - $1 # TODO known breakage vanished"
857 finalize_test_case_output fixed "$1"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800858}
859
860test_known_broken_failure_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800861 test_broken=$(($test_broken+1))
Ævar Arnfjörð Bjarmason6d006802022-07-28 01:13:29 +0200862 say_color warn "not ok $test_count - $1 # TODO known breakage"
863 finalize_test_case_output broken "$1"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800864}
Junio C Hamano886856a2005-05-14 00:24:27 -0700865
866test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700867 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700868}
869
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200870match_pattern_list () {
871 arg="$1"
872 shift
873 test -z "$*" && return 1
Jeff King560bf512021-06-16 06:23:07 -0400874 # We need to use "$*" to get field-splitting, but we want to
875 # disable globbing, since we are matching against an arbitrary
876 # $arg, not what's in the filesystem. Using "set -f" accomplishes
877 # that, but we must do it in a subshell to avoid impacting the
878 # rest of the script. The exit value of the subshell becomes
879 # the function's return value.
880 (
881 set -f
882 for pattern_ in $*
883 do
884 case "$arg" in
885 $pattern_)
886 exit 0
887 ;;
888 esac
889 done
890 exit 1
891 )
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200892}
893
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700894match_test_selector_list () {
Elijah Newrenf21ac362020-10-18 00:23:45 +0000895 operation="$1"
896 shift
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700897 title="$1"
898 shift
899 arg="$1"
900 shift
901 test -z "$1" && return 0
902
Elijah Newrenf21ac362020-10-18 00:23:45 +0000903 # Commas are accepted as separators.
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700904 OLDIFS=$IFS
Elijah Newrenf21ac362020-10-18 00:23:45 +0000905 IFS=','
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700906 set -- $1
907 IFS=$OLDIFS
908
909 # If the first selector is negative we include by default.
910 include=
911 case "$1" in
912 !*) include=t ;;
913 esac
914
915 for selector
916 do
917 orig_selector=$selector
918
919 positive=t
920 case "$selector" in
921 !*)
922 positive=
923 selector=${selector##?}
924 ;;
925 esac
926
927 test -z "$selector" && continue
928
929 case "$selector" in
930 *-*)
931 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
932 then
Elijah Newrenf21ac362020-10-18 00:23:45 +0000933 echo "error: $operation: invalid non-numeric in range" \
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700934 "start: '$orig_selector'" >&2
935 exit 1
936 fi
937 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
938 then
Elijah Newrenf21ac362020-10-18 00:23:45 +0000939 echo "error: $operation: invalid non-numeric in range" \
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700940 "end: '$orig_selector'" >&2
941 exit 1
942 fi
943 ;;
944 *)
945 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
946 then
Elijah Newrenf21ac362020-10-18 00:23:45 +0000947 case "$title" in *${selector}*)
948 include=$positive
949 ;;
950 esac
951 continue
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700952 fi
953 esac
954
955 # Short cut for "obvious" cases
956 test -z "$include" && test -z "$positive" && continue
957 test -n "$include" && test -n "$positive" && continue
958
959 case "$selector" in
960 -*)
961 if test $arg -le ${selector#-}
962 then
963 include=$positive
964 fi
965 ;;
966 *-)
967 if test $arg -ge ${selector%-}
968 then
969 include=$positive
970 fi
971 ;;
972 *-*)
973 if test ${selector%%-*} -le $arg \
974 && test $arg -le ${selector#*-}
975 then
976 include=$positive
977 fi
978 ;;
979 *)
980 if test $arg -eq $selector
981 then
982 include=$positive
983 fi
984 ;;
985 esac
986 done
987
988 test -n "$include"
989}
990
Thomas Rastff09af32013-06-23 20:12:56 +0200991maybe_teardown_verbose () {
992 test -z "$verbose_only" && return
993 exec 4>/dev/null 3>/dev/null
994 verbose=
995}
996
997last_verbose=t
998maybe_setup_verbose () {
999 test -z "$verbose_only" && return
Jeff King560bf512021-06-16 06:23:07 -04001000 if match_pattern_list $test_count "$verbose_only"
Thomas Rastff09af32013-06-23 20:12:56 +02001001 then
1002 exec 4>&2 3>&1
1003 # Emit a delimiting blank line when going from
1004 # non-verbose to verbose. Within verbose mode the
1005 # delimiter is printed by test_expect_*. The choice
1006 # of the initial $last_verbose is such that before
1007 # test 1, we do not print it.
1008 test -z "$last_verbose" && echo >&3 ""
1009 verbose=t
1010 else
1011 exec 4>/dev/null 3>/dev/null
1012 verbose=
1013 fi
1014 last_verbose=$verbose
1015}
1016
Thomas Rast5dfc3682013-06-23 20:12:57 +02001017maybe_teardown_valgrind () {
1018 test -z "$GIT_VALGRIND" && return
1019 GIT_VALGRIND_ENABLED=
1020}
1021
1022maybe_setup_valgrind () {
1023 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +02001024 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +02001025 then
1026 GIT_VALGRIND_ENABLED=t
1027 return
1028 fi
1029 GIT_VALGRIND_ENABLED=
Jeff King560bf512021-06-16 06:23:07 -04001030 if match_pattern_list $test_count "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +02001031 then
1032 GIT_VALGRIND_ENABLED=t
1033 fi
1034}
1035
Johannes Schindelin477dcad2020-03-26 15:35:26 +00001036trace_level_=0
Jeff King9b5fe782015-08-06 01:33:57 -04001037want_trace () {
Jeff Kingf5ba2de2017-12-08 05:47:17 -05001038 test "$trace" = t && {
1039 test "$verbose" = t || test "$verbose_log" = t
1040 }
Jeff King9b5fe782015-08-06 01:33:57 -04001041}
1042
Jeff Kinga136f6d2014-10-10 02:47:27 -04001043# This is a separate function because some tests use
1044# "return" to end a test_expect_success block early
1045# (and we want to make sure we run any cleanup like
1046# "set +x").
1047test_eval_inner_ () {
Jeff Kingcc48ddd2023-03-30 15:30:56 -04001048 eval "$*"
Jeff Kinga136f6d2014-10-10 02:47:27 -04001049}
1050
Jonathan Niedera7c58f22011-08-08 03:17:09 +02001051test_eval_ () {
Jeff King90c8a1d2017-12-08 05:47:08 -05001052 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1053 # with non-test commands. But once in "set -x" mode, we cannot prevent
Jeff Kinga136f6d2014-10-10 02:47:27 -04001054 # the shell from printing the "set +x" to turn it off (nor the saving
1055 # of $? before that). But we can make sure that the output goes to
1056 # /dev/null.
1057 #
Jeff King90c8a1d2017-12-08 05:47:08 -05001058 # There are a few subtleties here:
1059 #
1060 # - we have to redirect descriptor 4 in addition to 2, to cover
1061 # BASH_XTRACEFD
1062 #
1063 # - the actual eval has to come before the redirection block (since
1064 # it needs to see descriptor 4 to set up its stderr)
1065 #
1066 # - likewise, any error message we print must be outside the block to
1067 # access descriptor 4
1068 #
1069 # - checking $? has to come immediately after the eval, but it must
1070 # be _inside_ the block to avoid polluting the "set -x" output
1071 #
1072
Jeff Kingcc48ddd2023-03-30 15:30:56 -04001073 # Do not add anything extra (including LF) after '$*'
1074 test_eval_inner_ </dev/null >&3 2>&4 "
1075 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1076 $*"
Jeff Kinga136f6d2014-10-10 02:47:27 -04001077 {
Jeff Kinga136f6d2014-10-10 02:47:27 -04001078 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -04001079 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -04001080 then
Johannes Schindelin477dcad2020-03-26 15:35:26 +00001081 test 1 = $trace_level_ && set +x
1082 trace_level_=$(($trace_level_-1))
Jeff Kinga136f6d2014-10-10 02:47:27 -04001083 fi
Jeff King90c8a1d2017-12-08 05:47:08 -05001084 } 2>/dev/null 4>&2
1085
1086 if test "$test_eval_ret_" != 0 && want_trace
1087 then
1088 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1089 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -04001090 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +02001091}
1092
Jeff King1686de52023-03-30 15:27:49 -04001093fail_117 () {
1094 return 117
1095}
1096
Pavel Roskin4d9d62f2005-08-10 23:56:21 -04001097test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -05001098 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -07001099 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -04001100
Jeff King92b269f2015-04-22 16:09:57 -04001101 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff Kingbb79af92015-03-20 06:05:48 -04001102 # 117 is magic because it is unlikely to match the exit
1103 # code of other programs
Jeff Kingcc48ddd2023-03-30 15:30:56 -04001104 test_eval_inner_ "fail_117 && $1" </dev/null >&3 2>&4
Jeff King750b2602023-03-30 15:30:47 -04001105 if test $? != 117
Junio C Hamano99a64e42017-03-22 22:43:18 -07001106 then
Jeff King750b2602023-03-30 15:30:47 -04001107 BUG "broken &&-chain: $1"
Jeff Kingbb79af92015-03-20 06:05:48 -04001108 fi
1109 fi
1110
Thomas Rasta57397b2013-06-17 11:18:46 +02001111 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +02001112 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -05001113 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +02001114 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -07001115
Jeff Kinga136f6d2014-10-10 02:47:27 -04001116 if test -z "$immediate" || test $eval_ret = 0 ||
1117 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -07001118 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -07001119 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +02001120 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -07001121 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -07001122 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001123 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1124 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +00001125 echo ""
1126 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +02001127 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -04001128}
1129
Thomas Rastae753422013-06-18 14:25:59 +02001130test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +01001131 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +02001132 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +02001133 maybe_setup_valgrind
Johannes Schindelin0f5ae592022-05-21 22:18:51 +00001134 start_test_case_output "$@"
Thomas Rastae753422013-06-18 14:25:59 +02001135}
1136
1137test_finish_ () {
1138 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +02001139 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +02001140 maybe_teardown_verbose
Johannes Schindelinaf9912e2019-01-29 06:19:34 -08001141 if test -n "$GIT_TEST_TEE_OFFSET"
1142 then
1143 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1144 "$GIT_TEST_TEE_OUTPUT_FILE")
1145 fi
Thomas Rastae753422013-06-18 14:25:59 +02001146}
1147
1148test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -08001149 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -07001150 skipped_reason=
Jeff King560bf512021-06-16 06:23:07 -04001151 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001152 then
1153 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -07001154 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001155 fi
SZEDER Gábore0316692019-11-12 13:24:38 +01001156 if test -z "$to_skip" && test -n "$run_list" &&
Elijah Newrenf21ac362020-10-18 00:23:45 +00001157 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
SZEDER Gábore0316692019-11-12 13:24:38 +01001158 then
1159 to_skip=t
1160 skipped_reason="--run"
1161 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +08001162 if test -z "$to_skip" && test -n "$test_prereq" &&
1163 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +01001164 then
1165 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -07001166
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001167 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +08001168 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001169 then
Jonathan Nieder05236a52010-10-17 02:36:58 +08001170 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001171 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -07001172 skipped_reason="missing $missing_prereq${of_prereq}"
Fabian Stelzer49da4042021-11-20 16:03:59 +01001173
1174 # Keep a list of all the missing prereq for result aggregation
1175 if test -z "$missing_prereq"
1176 then
1177 test_missing_prereq=$missing_prereq
1178 else
1179 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1180 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -07001181 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001182
Ilya Bobyref2ac682014-04-30 02:50:43 -07001183 case "$to_skip" in
1184 t)
Johannes Schindelin22231902019-01-29 06:19:27 -08001185
Ilya Bobyref2ac682014-04-30 02:50:43 -07001186 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -08001187 : true
Johannes Schindelin3069f2a2022-05-21 22:18:56 +00001188 finalize_test_case_output skip "$@"
Junio C Hamano04ece592006-12-28 17:58:00 -08001189 ;;
1190 *)
1191 false
1192 ;;
1193 esac
1194}
1195
Thomas Rast342e9ef2012-02-17 11:25:09 +01001196# stub; perf-lib overrides it
1197test_at_end_hook_ () {
1198 :
1199}
1200
Johannes Schindelin900721e2019-03-13 13:24:11 +01001201test_atexit_cleanup=:
1202test_atexit_handler () {
1203 # In a succeeding test script 'test_atexit_handler' is invoked
1204 # twice: first from 'test_done', then from 'die' in the trap on
1205 # EXIT.
1206 # This condition and resetting 'test_atexit_cleanup' below makes
1207 # sure that the registered cleanup commands are run only once.
1208 test : != "$test_atexit_cleanup" || return 0
1209
1210 setup_malloc_check
1211 test_eval_ "$test_atexit_cleanup"
1212 test_atexit_cleanup=:
1213 teardown_malloc_check
1214}
1215
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +02001216sanitize_leak_log_message_ () {
1217 local new="$1" &&
1218 local old="$2" &&
1219 local file="$3" &&
1220
1221 printf "With SANITIZE=leak at exit we have %d leak logs, but started with %d
1222
1223This means that we have a blindspot where git is leaking but we're
1224losing the exit code somewhere, or not propagating it appropriately
1225upwards!
1226
1227See the logs at \"%s.*\";
1228those logs are reproduced below." \
1229 "$new" "$old" "$file"
1230}
1231
1232check_test_results_san_file_ () {
1233 if test -z "$TEST_RESULTS_SAN_FILE"
1234 then
1235 return
1236 fi &&
1237 local old="$TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP" &&
1238 local new="$(nr_san_dir_leaks_)" &&
1239
1240 if test $new -le $old
1241 then
1242 return
1243 fi &&
1244 local out="$(sanitize_leak_log_message_ "$new" "$old" "$TEST_RESULTS_SAN_FILE")" &&
1245 say_color error "$out" &&
1246 if test "$old" != 0
1247 then
1248 echo &&
1249 say_color error "The logs include output from past runs to avoid" &&
1250 say_color error "that remove 'test-results' between runs."
1251 fi &&
1252 say_color error "$(cat "$TEST_RESULTS_SAN_FILE".*)" &&
1253
1254 if test -n "$passes_sanitize_leak" && test "$test_failure" = 0
1255 then
1256 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, exit non-zero!" &&
1257 invert_exit_code=t
1258 elif test -n "$passes_sanitize_leak"
1259 then
1260 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, and we're failing for other reasons too..." &&
1261 invert_exit_code=
1262 elif test -n "$sanitize_leak_check" && test "$test_failure" = 0
1263 then
1264 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1265 invert_exit_code=
1266 elif test -n "$sanitize_leak_check"
1267 then
1268 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1269 invert_exit_code=t
1270 else
1271 say "With GIT_TEST_SANITIZE_LEAK_LOG=true our logs revealed a memory leak, exit non-zero!" &&
1272 invert_exit_code=t
1273 fi
1274}
1275
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001276test_done () {
Johannes Schindelin900721e2019-03-13 13:24:11 +01001277 # Run the atexit commands _before_ the trash directory is
1278 # removed, so the commands can access pidfiles and socket files.
1279 test_atexit_handler
1280
Johannes Schindelin78d5e4c2022-05-21 22:18:46 +00001281 finalize_test_output
Johannes Schindelin22231902019-01-29 06:19:27 -08001282
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001283 if test -z "$HARNESS_ACTIVE"
1284 then
SZEDER Gábor62c379b2019-01-05 02:08:56 +01001285 mkdir -p "$TEST_RESULTS_DIR"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +00001286
SZEDER Gábor62c379b2019-01-05 02:08:56 +01001287 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +02001288 total $test_count
1289 success $test_success
1290 fixed $test_fixed
1291 broken $test_broken
1292 failed $test_failure
Fabian Stelzer49da4042021-11-20 16:03:59 +01001293 missing_prereq $test_missing_prereq
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +02001294
1295 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +00001296 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -08001297
1298 if test "$test_fixed" != 0
1299 then
Thomas Rast633fe502013-10-19 23:06:08 +02001300 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -08001301 fi
1302 if test "$test_broken" != 0
1303 then
Thomas Rast633fe502013-10-19 23:06:08 +02001304 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +00001305 fi
1306 if test "$test_broken" != 0 || test "$test_fixed" != 0
1307 then
1308 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1309 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -08001310 else
Adam Spiersb73d9a22012-12-16 18:28:15 +00001311 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -08001312 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -08001313 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001314 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -08001315 0)
Ævar Arnfjörð Bjarmason5beca492022-07-28 01:13:37 +02001316 if test $test_remaining -gt 0
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001317 then
Ævar Arnfjörð Bjarmason5beca492022-07-28 01:13:37 +02001318 say_color pass "# passed all $msg"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +00001319 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001320
Ævar Arnfjörð Bjarmason5beca492022-07-28 01:13:37 +02001321 # Maybe print SKIP message
1322 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1323 case "$test_count" in
1324 0)
1325 say "1..$test_count${skip_all:+ $skip_all}"
1326 ;;
1327 *)
1328 test -z "$skip_all" ||
1329 say_color warn "$skip_all"
1330 say "1..$test_count"
1331 ;;
1332 esac
1333
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +02001334 if test -n "$stress" && test -n "$invert_exit_code"
1335 then
1336 # We're about to move our "$TRASH_DIRECTORY"
1337 # to "$TRASH_DIRECTORY.stress-failed" if
1338 # --stress is combined with
1339 # --invert-exit-code.
1340 say "with --stress and --invert-exit-code we're not removing '$TRASH_DIRECTORY'"
1341 elif test -z "$debug" && test -n "$remove_trash"
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001342 then
Junio C Hamano06478da2017-04-23 17:15:09 -07001343 test -d "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001344 error "Tests passed but trash directory already removed before test cleanup; aborting"
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001345
Junio C Hamano06478da2017-04-23 17:15:09 -07001346 cd "$TRASH_DIRECTORY/.." &&
Johannes Schindelin046e90d2019-01-29 06:19:35 -08001347 rm -fr "$TRASH_DIRECTORY" || {
1348 # try again in a bit
1349 sleep 5;
1350 rm -fr "$TRASH_DIRECTORY"
1351 } ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001352 error "Tests passed but test cleanup failed; aborting"
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001353 fi
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +02001354
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +02001355 check_test_results_san_file_ "$test_failure"
1356
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +02001357 if test -z "$skip_all" && test -n "$invert_exit_code"
1358 then
1359 say_color warn "# faking up non-zero exit with --invert-exit-code"
1360 GIT_EXIT_OK=t
1361 exit 1
1362 fi
1363
Thomas Rast342e9ef2012-02-17 11:25:09 +01001364 test_at_end_hook_
1365
Ævar Arnfjörð Bjarmason25c23512022-07-28 01:13:31 +02001366 GIT_EXIT_OK=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001367 exit 0 ;;
1368
1369 *)
Ævar Arnfjörð Bjarmason5beca492022-07-28 01:13:37 +02001370 say_color error "# failed $test_failure among $msg"
1371 say "1..$test_count"
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +00001372
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +02001373 check_test_results_san_file_ "$test_failure"
1374
Ævar Arnfjörð Bjarmason46fb0572022-07-28 01:13:32 +02001375 if test -n "$invert_exit_code"
1376 then
1377 _invert_exit_code_failure_end_blurb
1378 GIT_EXIT_OK=t
1379 exit 0
1380 fi
1381
Ævar Arnfjörð Bjarmason25c23512022-07-28 01:13:31 +02001382 GIT_EXIT_OK=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001383 exit 1 ;;
1384
1385 esac
1386}
1387
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001388if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001389then
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001390 make_symlink () {
1391 test -h "$2" &&
1392 test "$1" = "$(readlink "$2")" || {
1393 # be super paranoid
1394 if mkdir "$2".lock
1395 then
1396 rm -f "$2" &&
1397 ln -s "$1" "$2" &&
1398 rm -r "$2".lock
1399 else
1400 while test -d "$2".lock
1401 do
1402 say "Waiting for lock on $2."
1403 sleep 1
1404 done
1405 fi
1406 }
1407 }
1408
1409 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -04001410 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -08001411 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -04001412 test -x "$1" ||
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +00001413 test "# " = "$(test_copy_bytes 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -04001414 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001415
1416 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +02001417 case "$base" in
1418 test-*)
1419 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1420 ;;
1421 *)
1422 symlink_target="$GIT_BUILD_DIR/$base"
1423 ;;
1424 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001425 # do not override scripts
1426 if test -x "$symlink_target" &&
1427 test ! -d "$symlink_target" &&
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +00001428 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001429 then
1430 symlink_target=../valgrind.sh
1431 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001432 case "$base" in
1433 *.sh|*.perl)
1434 symlink_target=../unprocessed-script
1435 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001436 # create the link, or replace it if it is out of date
1437 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1438 }
1439
Thomas Rast26a07302013-10-19 23:06:07 +02001440 # override all git executables in TEST_DIRECTORY/..
1441 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1442 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +02001443 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +02001444 do
1445 make_valgrind_symlink $file
1446 done
1447 # special-case the mergetools loadables
1448 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1449 OLDIFS=$IFS
1450 IFS=:
1451 for path in $PATH
1452 do
1453 ls "$path"/git-* 2> /dev/null |
1454 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001455 do
Thomas Rast26a07302013-10-19 23:06:07 +02001456 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001457 done
Thomas Rast26a07302013-10-19 23:06:07 +02001458 done
1459 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001460 PATH=$GIT_VALGRIND/bin:$PATH
1461 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1462 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +02001463 GIT_VALGRIND_MODE="$valgrind"
1464 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +02001465 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +02001466 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +02001467 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001468elif test -n "$GIT_TEST_INSTALLED"
1469then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001470 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1471 error "Cannot run git from $GIT_TEST_INSTALLED."
Johannes Schindelin16df35c2018-11-12 05:48:33 -08001472 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001473 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1474else # normal case, use ../bin-wrappers only unless $with_dashes:
Johannes Schindelindd167a32019-01-29 06:19:37 -08001475 if test -n "$no_bin_wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001476 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001477 with_dashes=t
Johannes Schindelindd167a32019-01-29 06:19:37 -08001478 else
1479 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1480 if ! test -x "$git_bin_dir/git"
1481 then
1482 if test -z "$with_dashes"
1483 then
1484 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1485 fi
1486 with_dashes=t
1487 fi
1488 PATH="$git_bin_dir:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001489 fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001490 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001491 if test -n "$with_dashes"
1492 then
Johannes Schindelinca7312d2019-01-29 06:19:35 -08001493 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001494 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001495fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001496GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -05001497GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -05001498GIT_ATTR_NOSYSTEM=1
SZEDER Gábor614c3d82021-08-29 11:25:36 +02001499GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1500export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
Junio C Hamano49ccb082005-12-07 21:52:28 -08001501
Junio C Hamano5e87eae2010-06-11 09:40:25 -07001502if test -z "$GIT_TEST_CMP"
1503then
1504 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1505 then
1506 GIT_TEST_CMP="$DIFF -c"
1507 else
1508 GIT_TEST_CMP="$DIFF -u"
1509 fi
1510fi
1511
Ævar Arnfjörð Bjarmason20d2a302017-12-10 21:13:33 +00001512GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
Petr Baudis6fcca932006-07-03 23:16:32 +02001513export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001514test -d "$GIT_BUILD_DIR"/templates/blt || {
Ævar Arnfjörð Bjarmason25c23512022-07-28 01:13:31 +02001515 BAIL_OUT "You haven't built things yet, have you?"
Junio C Hamanoeea42062005-12-10 20:55:32 -08001516}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001517
Johannes Schindelind6096152019-01-21 07:12:19 -08001518if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001519then
Ævar Arnfjörð Bjarmason25c23512022-07-28 01:13:31 +02001520 BAIL_OUT 'You need to build test-tool; Run "make t/helper/test-tool" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -08001521fi
1522
Ævar Arnfjörð Bjarmasonedc23842021-05-10 16:19:00 +02001523# Are we running this test at all?
1524remove_trash=
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001525this_test=${0##*/}
1526this_test=${this_test%%-*}
Jeff King560bf512021-06-16 06:23:07 -04001527if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001528then
1529 say_color info >&3 "skipping test $this_test altogether"
1530 skip_all="skip all tests in $this_test"
1531 test_done
1532fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001533
Ævar Arnfjörð Bjarmason366bd122022-07-28 01:13:34 +02001534BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK () {
1535 BAIL_OUT "$1 has no effect except when compiled with SANITIZE=leak"
1536}
1537
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001538if test -n "$SANITIZE_LEAK"
1539then
Ævar Arnfjörð Bjarmasone92684e2022-07-28 01:13:38 +02001540 # Normalize with test_bool_env
1541 passes_sanitize_leak=
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001542
Ævar Arnfjörð Bjarmason4a1baac2023-01-12 17:03:21 +01001543 # We need to see TEST_PASSES_SANITIZE_LEAK in "test-tool
1544 # env-helper" (via test_bool_env)
Ævar Arnfjörð Bjarmasone92684e2022-07-28 01:13:38 +02001545 export TEST_PASSES_SANITIZE_LEAK
1546 if test_bool_env TEST_PASSES_SANITIZE_LEAK false
1547 then
1548 passes_sanitize_leak=t
1549 fi
1550
1551 if test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check"
1552 then
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +02001553 sanitize_leak_check=t
Ævar Arnfjörð Bjarmasone92684e2022-07-28 01:13:38 +02001554 if test -n "$invert_exit_code"
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001555 then
Ævar Arnfjörð Bjarmasone92684e2022-07-28 01:13:38 +02001556 BAIL_OUT "cannot use --invert-exit-code under GIT_TEST_PASSING_SANITIZE_LEAK=check"
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001557 fi
Ævar Arnfjörð Bjarmasone92684e2022-07-28 01:13:38 +02001558
1559 if test -z "$passes_sanitize_leak"
1560 then
1561 say "in GIT_TEST_PASSING_SANITIZE_LEAK=check mode, setting --invert-exit-code for TEST_PASSES_SANITIZE_LEAK != true"
1562 invert_exit_code=t
1563 fi
1564 elif test -z "$passes_sanitize_leak" &&
1565 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1566 then
1567 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1568 test_done
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001569 fi
Ævar Arnfjörð Bjarmason366bd122022-07-28 01:13:34 +02001570
1571 if test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1572 then
1573 if ! mkdir -p "$TEST_RESULTS_SAN_DIR"
1574 then
1575 BAIL_OUT "cannot create $TEST_RESULTS_SAN_DIR"
1576 fi &&
1577 TEST_RESULTS_SAN_FILE="$TEST_RESULTS_SAN_DIR/$TEST_RESULTS_SAN_FILE_PFX"
1578
Ævar Arnfjörð Bjarmasonfaececa2022-07-28 01:13:39 +02001579 # In case "test-results" is left over from a previous
1580 # run: Only report if new leaks show up.
1581 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP=$(nr_san_dir_leaks_)
1582
Ævar Arnfjörð Bjarmason366bd122022-07-28 01:13:34 +02001583 # Don't litter *.leak dirs if there was nothing to report
1584 test_atexit "rmdir \"$TEST_RESULTS_SAN_DIR\" 2>/dev/null || :"
1585
1586 prepend_var LSAN_OPTIONS : dedup_token_length=9999
1587 prepend_var LSAN_OPTIONS : log_exe_name=1
1588 prepend_var LSAN_OPTIONS : log_path=\"$TEST_RESULTS_SAN_FILE\"
1589 export LSAN_OPTIONS
1590 fi
Ævar Arnfjörð Bjarmasone92684e2022-07-28 01:13:38 +02001591elif test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check" ||
1592 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001593then
Ævar Arnfjörð Bjarmason366bd122022-07-28 01:13:34 +02001594 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_PASSING_SANITIZE_LEAK=true"
1595elif test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1596then
1597 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_SANITIZE_LEAK_LOG=true"
Ævar Arnfjörð Bjarmason956d2e42021-09-23 11:20:46 +02001598fi
1599
Jeff King7b6555a2023-03-30 15:27:38 -04001600if test "${GIT_TEST_CHAIN_LINT:-1}" != 0 &&
1601 test "${GIT_TEST_EXT_CHAIN_LINT:-1}" != 0
Eric Sunshine23a14f32022-09-01 00:29:54 +00001602then
1603 "$PERL_PATH" "$TEST_DIRECTORY/chainlint.pl" "$0" ||
1604 BUG "lint error (see '?!...!? annotations above)"
1605fi
1606
Ævar Arnfjörð Bjarmasonedc23842021-05-10 16:19:00 +02001607# Last-minute variable setup
Philippe Blainadd52402021-09-06 04:38:59 +00001608USER_HOME="$HOME"
Ævar Arnfjörð Bjarmasonedc23842021-05-10 16:19:00 +02001609HOME="$TRASH_DIRECTORY"
1610GNUPGHOME="$HOME/gnupg-home-not-used"
Philippe Blainadd52402021-09-06 04:38:59 +00001611export HOME GNUPGHOME USER_HOME
Ævar Arnfjörð Bjarmasonedc23842021-05-10 16:19:00 +02001612
Ævar Arnfjörð Bjarmason5d22e182021-10-11 03:41:59 +02001613# "rm -rf" existing trash directory, even if a previous run left it
1614# with bad permissions.
1615remove_trash_directory () {
1616 dir="$1"
1617 if ! rm -rf "$dir" 2>/dev/null
1618 then
1619 chmod -R u+rwx "$dir"
1620 rm -rf "$dir"
1621 fi
1622 ! test -d "$dir"
1623}
1624
Johannes Sixtee9fb682009-03-13 22:55:27 +01001625# Test repository
Ævar Arnfjörð Bjarmason5d22e182021-10-11 03:41:59 +02001626remove_trash_directory "$TRASH_DIRECTORY" || {
Ævar Arnfjörð Bjarmason25c23512022-07-28 01:13:31 +02001627 BAIL_OUT 'cannot prepare test area'
Johannes Sixt6fd11062009-03-13 23:00:15 +01001628}
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001629
Ævar Arnfjörð Bjarmasonedc23842021-05-10 16:19:00 +02001630remove_trash=t
Johannes Sixt704a3142009-03-04 22:38:24 +01001631if test -z "$TEST_NO_CREATE_REPO"
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001632then
Ævar Arnfjörð Bjarmasone9422922022-06-03 13:15:04 +02001633 git init \
1634 ${TEST_CREATE_REPO_NO_TEMPLATE:+--template=} \
1635 "$TRASH_DIRECTORY" >&3 2>&4 ||
Ævar Arnfjörð Bjarmasonf0d4d392021-05-10 16:19:10 +02001636 error "cannot run git init"
Johan Herlandd4e1b472009-11-18 02:42:31 +01001637else
Michał Kiedrowicz8f852ce2011-05-09 23:52:07 +02001638 mkdir -p "$TRASH_DIRECTORY"
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001639fi
Jeff King1b19ccd2009-04-03 15:33:59 -04001640
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001641# Use -P to resolve symlinks in our working directory so that the cwd
Jonathan Nieder30955222011-02-22 23:41:22 +00001642# in subprocesses like git equals our $PWD (for pathname comparisons).
Ævar Arnfjörð Bjarmason25c23512022-07-28 01:13:31 +02001643cd -P "$TRASH_DIRECTORY" || BAIL_OUT "cannot cd -P to \"$TRASH_DIRECTORY\""
Jeff Kingf838ce52013-03-10 21:31:47 -04001644
Johannes Schindelin78d5e4c2022-05-21 22:18:46 +00001645start_test_output "$0"
Johannes Schindelin22231902019-01-29 06:19:27 -08001646
brian m. carlson192b5172020-02-22 20:17:31 +00001647# Convenience
Ævar Arnfjörð Bjarmason70507912021-09-11 13:17:51 +02001648# A regexp to match 5 and 35 hexdigits
brian m. carlson192b5172020-02-22 20:17:31 +00001649_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1650_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
brian m. carlson192b5172020-02-22 20:17:31 +00001651
1652test_oid_init
1653
1654ZERO_OID=$(test_oid zero)
1655OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
brian m. carlsona1142962020-05-13 00:53:41 +00001656OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
brian m. carlson192b5172020-02-22 20:17:31 +00001657EMPTY_TREE=$(test_oid empty_tree)
1658EMPTY_BLOB=$(test_oid empty_blob)
brian m. carlson192b5172020-02-22 20:17:31 +00001659
Junio C Hamano11f470a2019-02-09 10:25:26 -08001660# Provide an implementation of the 'yes' utility; the upper bound
1661# limit is there to help Windows that cannot stop this loop from
1662# wasting cycles when the downstream stops reading, so do not be
1663# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1664# limit the output of the yes utility", 2016-02-02)
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001665yes () {
Johannes Sixt5397ea32009-03-14 22:21:27 +01001666 if test $# = 0
1667 then
1668 y=y
Johannes Sixt41141562009-03-13 23:35:24 +01001669 else
1670 y="$*"
1671 fi
1672
Johannes Schindelin6129c932016-02-02 19:15:53 +01001673 i=0
1674 while test $i -lt 99
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001675 do
Johannes Schindelin6129c932016-02-02 19:15:53 +01001676 echo "$y"
1677 i=$(($i+1))
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001678 done
1679}
1680
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001681# The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1682# thus needs to be set up really early, and set an internal variable
1683# for convenience so the hot test_set_prereq() codepath doesn't need
Ævar Arnfjörð Bjarmason4a1baac2023-01-12 17:03:21 +01001684# to call "test-tool env-helper" (via test_bool_env). Only do that work
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001685# if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001686GIT_TEST_FAIL_PREREQS_INTERNAL=
1687if test -n "$GIT_TEST_FAIL_PREREQS"
1688then
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001689 if test_bool_env GIT_TEST_FAIL_PREREQS false
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001690 then
1691 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1692 test_set_prereq FAIL_PREREQS
1693 fi
1694else
1695 test_lazy_prereq FAIL_PREREQS '
SZEDER Gábor43a2afe2019-11-22 14:14:36 +01001696 test_bool_env GIT_TEST_FAIL_PREREQS false
Ævar Arnfjörð Bjarmasonc7400392019-06-21 12:18:12 +02001697 '
1698fi
1699
Ed Maste7187c7b2019-11-27 17:15:07 +00001700# Fix some commands on Windows, and other OS-specific things
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001701uname_s=$(uname -s)
1702case $uname_s in
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001703*MINGW*)
1704 # Windows has its own (incompatible) sort and find
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001705 sort () {
1706 /usr/bin/sort "$@"
1707 }
1708 find () {
1709 /usr/bin/find "$@"
1710 }
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001711 # git sees Windows-style pwd
1712 pwd () {
Johannes Sixt704a3142009-03-04 22:38:24 +01001713 builtin pwd -W
1714 }
1715 # no POSIX permissions
1716 # backslashes in pathspec are converted to '/'
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001717 # exec does not inherit the PID
1718 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +02001719 test_set_prereq NATIVE_CRLF
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001720 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001721 test_set_prereq GREP_STRIPS_CR
Adam Dinwoodiebccc37f2021-04-29 21:11:44 +01001722 test_set_prereq WINDOWS
Johannes Schindelina3795bf2022-12-06 15:07:47 +00001723 GIT_TEST_CMP="GIT_DIR=/dev/null git diff --no-index --ignore-cr-at-eol --"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001724 ;;
1725*CYGWIN*)
1726 test_set_prereq POSIXPERM
1727 test_set_prereq EXECKEEPSPID
1728 test_set_prereq CYGWIN
1729 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001730 test_set_prereq GREP_STRIPS_CR
Adam Dinwoodiebccc37f2021-04-29 21:11:44 +01001731 test_set_prereq WINDOWS
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001732 ;;
1733*)
1734 test_set_prereq POSIXPERM
1735 test_set_prereq BSLASHPSPEC
1736 test_set_prereq EXECKEEPSPID
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001737 ;;
1738esac
1739
Greg Priceddcfc7c2020-05-15 22:33:38 -07001740# Detect arches where a few things don't work
1741uname_m=$(uname -m)
1742case $uname_m in
1743parisc* | hppa*)
1744 test_set_prereq HPPA
1745 ;;
1746esac
1747
Han-Wen Nienhuysc305e662021-05-31 16:56:29 +00001748test_set_prereq REFFILES
1749
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001750( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Ævar Arnfjörð Bjarmason7596fe92022-06-15 12:36:32 +02001751test -z "$NO_CURL" && test_set_prereq LIBCURL
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001752test -z "$NO_PERL" && test_set_prereq PERL
Ævar Arnfjörð Bjarmason68c7d272017-05-25 19:45:31 +00001753test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001754test -z "$NO_PYTHON" && test_set_prereq PYTHON
Ævar Arnfjörð Bjarmason75997302021-01-24 02:58:33 +01001755test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
Ævar Arnfjörð Bjarmasonce9a2572017-11-23 14:16:57 +00001756test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001757test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Ævar Arnfjörð Bjarmason2cdc2922021-09-23 11:20:45 +02001758test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
Ævar Arnfjörð Bjarmason58407e02022-05-12 15:32:15 -07001759test -n "$GIT_VALGRIND_ENABLED" && test_set_prereq VALGRIND
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001760
Nguyễn Thái Ngọc Duy4592e602018-08-18 16:41:28 +02001761if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1762then
1763 GIT_TEST_CHECK_CACHE_TREE=true
1764 export GIT_TEST_CHECK_CACHE_TREE
1765fi
1766
Junio C Hamano04083f22012-07-26 15:50:45 -07001767test_lazy_prereq PIPE '
1768 # test whether the filesystem supports FIFOs
Ramsay Jones7b7bea22017-09-17 23:56:00 +01001769 test_have_prereq !MINGW,!CYGWIN &&
1770 rm -f testfifo && mkfifo testfifo
Junio C Hamano04083f22012-07-26 15:50:45 -07001771'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001772
Michael J Gruberac39aa62012-07-26 15:39:53 +02001773test_lazy_prereq SYMLINKS '
1774 # test whether the filesystem supports symbolic links
1775 ln -s x y && test -h y
1776'
1777
Thomas Bétous3e7d4882021-08-02 21:07:30 +00001778test_lazy_prereq SYMLINKS_WINDOWS '
1779 # test whether symbolic links are enabled on Windows
1780 test_have_prereq MINGW &&
1781 cmd //c "mklink y x" &> /dev/null && test -h y
1782'
1783
Jonathan Niederb018c732013-11-25 13:02:16 -08001784test_lazy_prereq FILEMODE '
1785 test "$(git config --bool core.filemode)" = true
1786'
1787
Michael J Gruberac39aa62012-07-26 15:39:53 +02001788test_lazy_prereq CASE_INSENSITIVE_FS '
1789 echo good >CamelCase &&
1790 echo bad >camelcase &&
1791 test "$(cat CamelCase)" != good
1792'
1793
William Chargin6ec63302018-08-06 11:35:08 -07001794test_lazy_prereq FUNNYNAMES '
1795 test_have_prereq !MINGW &&
1796 touch -- \
1797 "FUNNYNAMES tab embedded" \
1798 "FUNNYNAMES \"quote embedded\"" \
1799 "FUNNYNAMES newline
1800embedded" 2>/dev/null &&
1801 rm -- \
1802 "FUNNYNAMES tab embedded" \
1803 "FUNNYNAMES \"quote embedded\"" \
1804 "FUNNYNAMES newline
1805embedded" 2>/dev/null
1806'
1807
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001808test_lazy_prereq UTF8_NFD_TO_NFC '
1809 # check whether FS converts nfd unicode to nfc
1810 auml=$(printf "\303\244")
1811 aumlcdiar=$(printf "\141\314\210")
1812 >"$auml" &&
Torsten Bögershausen742ae102018-04-30 08:35:19 +02001813 test -f "$aumlcdiar"
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001814'
1815
Jeff King09feffb2012-11-14 16:33:40 -08001816test_lazy_prereq AUTOIDENT '
1817 sane_unset GIT_AUTHOR_NAME &&
1818 sane_unset GIT_AUTHOR_EMAIL &&
1819 git var GIT_AUTHOR_IDENT
1820'
1821
Junio C Hamano6219bb22014-06-09 12:23:30 -07001822test_lazy_prereq EXPENSIVE '
1823 test -n "$GIT_TEST_LONG"
1824'
1825
Ævar Arnfjörð Bjarmason5b1fe6e2018-01-30 21:21:23 +00001826test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1827 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1828'
1829
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001830test_lazy_prereq USR_BIN_TIME '
1831 test -x /usr/bin/time
1832'
1833
Jeff King1767c512015-01-16 04:16:49 -05001834test_lazy_prereq NOT_ROOT '
1835 uid=$(id -u) &&
1836 test "$uid" != 0
1837'
1838
Jonathan Tan63b747c2016-09-09 10:36:28 -07001839test_lazy_prereq JGIT '
Todd Zullingerabd0f282019-05-14 21:36:33 -04001840 jgit --version
Jonathan Tan63b747c2016-09-09 10:36:28 -07001841'
1842
Junio C Hamano719c3da2016-01-19 14:09:37 -08001843# SANITY is about "can you correctly predict what the filesystem would
1844# do by only looking at the permission bits of the files and
1845# directories?" A typical example of !SANITY is running the test
1846# suite as root, where a test may expect "chmod -r file && cat file"
1847# to fail because file is supposed to be unreadable after a successful
1848# chmod. In an environment (i.e. combination of what filesystem is
1849# being used and who is running the tests) that lacks SANITY, you may
1850# be able to delete or create a file when the containing directory
1851# doesn't have write permissions, or access a file even if the
1852# containing directory doesn't have read or execute permissions.
1853
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001854test_lazy_prereq SANITY '
1855 mkdir SANETESTD.1 SANETESTD.2 &&
1856
1857 chmod +w SANETESTD.1 SANETESTD.2 &&
1858 >SANETESTD.1/x 2>SANETESTD.2/x &&
1859 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001860 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001861 chmod -rx SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001862 BUG "cannot prepare SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001863
Junio C Hamano719c3da2016-01-19 14:09:37 -08001864 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001865 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1866 status=$?
1867
1868 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1869 rm -rf SANETESTD.1 SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001870 BUG "cannot clean SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001871 return $status
1872'
Jeff Kingf838ce52013-03-10 21:31:47 -04001873
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001874test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
Jeff Kingf838ce52013-03-10 21:31:47 -04001875GIT_UNZIP=${GIT_UNZIP:-unzip}
1876test_lazy_prereq UNZIP '
1877 "$GIT_UNZIP" -v
1878 test $? -ne 127
1879'
Jeff King9a308de2015-03-13 00:53:07 -04001880
1881run_with_limited_cmdline () {
1882 (ulimit -s 128 && "$@")
1883}
1884
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001885test_lazy_prereq CMDLINE_LIMIT '
Greg Priceddcfc7c2020-05-15 22:33:38 -07001886 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001887 run_with_limited_cmdline true
1888'
Jeff King6b9c38e2016-07-11 19:54:18 -04001889
Michael J Gruber4db464f2017-09-07 16:02:20 +02001890run_with_limited_stack () {
1891 (ulimit -s 128 && "$@")
1892}
1893
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001894test_lazy_prereq ULIMIT_STACK_SIZE '
Greg Priceddcfc7c2020-05-15 22:33:38 -07001895 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001896 run_with_limited_stack true
1897'
Michael J Gruber4db464f2017-09-07 16:02:20 +02001898
Taylor Blaub30fdb42020-04-23 15:41:06 -06001899run_with_limited_open_files () {
1900 (ulimit -n 32 && "$@")
1901}
1902
1903test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1904 test_have_prereq !MINGW,!CYGWIN &&
1905 run_with_limited_open_files true
1906'
1907
Jeff King6b9c38e2016-07-11 19:54:18 -04001908build_option () {
1909 git version --build-options |
1910 sed -ne "s/^$1: //p"
1911}
1912
Carlo Marcelo Arenas Belón970fa572021-11-02 15:46:06 +00001913test_lazy_prereq SIZE_T_IS_64BIT '
1914 test 8 -eq "$(build_option sizeof-size_t)"
1915'
1916
Jeff King6b9c38e2016-07-11 19:54:18 -04001917test_lazy_prereq LONG_IS_64BIT '
1918 test 8 -le "$(build_option sizeof-long)"
1919'
Johannes Schindelina07fb052017-04-20 22:52:13 +02001920
Nguyễn Thái Ngọc Duya801a7c2018-03-24 08:44:36 +01001921test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1922test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
Jeff Kinge9184b02018-04-03 10:01:57 -04001923
1924test_lazy_prereq CURL '
1925 curl --version
1926'
brian m. carlsond16ab632018-05-13 02:24:11 +00001927
1928# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1929# which will not work with other hash algorithms and tests that work but don't
1930# test anything meaningful (e.g. special values which cause short collisions).
1931test_lazy_prereq SHA1 '
brian m. carlsonc49fe072020-07-29 23:14:25 +00001932 case "$GIT_DEFAULT_HASH" in
1933 sha1) true ;;
1934 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1935 *) false ;;
1936 esac
brian m. carlsond16ab632018-05-13 02:24:11 +00001937'
Johannes Schindelin11aad462018-10-31 13:02:02 -07001938
Derrick Stolee2fec6042020-09-11 17:49:18 +00001939# Ensure that no test accidentally triggers a Git command
Derrick Stolee31345d52020-11-24 04:16:42 +00001940# that runs the actual maintenance scheduler, affecting a user's
1941# system permanently.
1942# Tests that verify the scheduler integration must set this locally
Derrick Stolee2fec6042020-09-11 17:49:18 +00001943# to avoid errors.
Derrick Stolee31345d52020-11-24 04:16:42 +00001944GIT_TEST_MAINT_SCHEDULER="none:exit 1"
Jeff Hostetlerdd77cf62022-03-25 18:03:02 +00001945
1946# Does this platform support `git fsmonitor--daemon`
1947#
1948test_lazy_prereq FSMONITOR_DAEMON '
1949 git version --build-options >output &&
1950 grep "feature: fsmonitor--daemon" output
1951'